<?php

/*
=====================================================
 This ExpressionEngine plugin was created by Laisvunas
 - http://expressionengine.com/forums/member/38398/
=====================================================
 Licensed under Creative Commons Attribution-Share Alike 3.0 Unported licence
 - http://creativecommons.org/licenses/by-sa/3.0/
=====================================================
 File: pi.math_plus.php
-----------------------------------------------------
 Purpose: provides support for mathematical operations 
 in templates.
=====================================================
*/

$plugin_info = array(
						'pi_name'			=> 'Math Plus',
						'pi_version'		=> '1.0.2',
						'pi_author'			=> 'Laisvunas',
						'pi_author_url'		=> 'http://expressionengine.com/forums/member/38398/',
						'pi_description'	=> 'Provides support for mathematical operations 
 in templates',
						'pi_usage'			=> Math_plus::usage()
					);
     
class Math_plus {

  var $return_data = '';
  
  function Math_plus()
  {
    global $TMPL, $DB, $FNS;
    
    // Fetch tagdata
    $tagdata = $TMPL->tagdata;
    
    // Fetch parameters
  		$calculate = $TMPL->fetch_param('calculate');
  		$invalid_input = $TMPL->fetch_param('invalid_input');
  		
  		// Define variables
  		$found_invalid = FALSE;
  		$result = '';
    $conds = array();
    
    // "calculate" parameter is required
  		if ($calculate === FALSE)
  		{
      if ($invalid_input === 'alert')
      {
        echo 'ERROR! Parameter "calculate" of exp:simple_math tag not defined!<br><br>';
      }
      $found_invalid = TRUE;
    }
    
    if ($found_invalid === FALSE)
    {
      $calculate = $DB->escape_str($calculate);
      //echo '1 $calculate: '.$calculate.'<br><br>';
    		$calculate = str_replace('&#47;', "/", $calculate);
    		//echo '2 $calculate: '.$calculate.'<br><br>';
    		$evalstring = '$result = '.$calculate.';';
    		@eval($evalstring);
    		//echo '$result: '.$result.'<br><br>';
      $conds['math_plus_result'] = $result;
      
      // Evaluate conditionals
      $tagdata = $FNS->prep_conditionals($tagdata, $conds);
      // Substitutes {simple_math_result} variable with matching value
      $tagdata = $TMPL->swap_var_single('math_plus_result', $conds['math_plus_result'], $tagdata);
    }
    else
    {
      $conds['math_plus_result'] = '';
      
      // Evaluate conditionals
      $tagdata = $FNS->prep_conditionals($tagdata, $conds);
      // Substitutes {simple_math_result} variable with matching value
      $tagdata = $TMPL->swap_var_single('math_plus_result', $conds['math_plus_result'], $tagdata);
    }
    
    return $this->return_data = $tagdata;
  }
  
// ----------------------------------------
//  Plugin Usage
// ----------------------------------------
// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>
PARAMETERS

1) calculate - Required. Alows you to input a string consisting of numbers,
symbols of mathematical operations and round brackets, e.g
calculate = "(10 + 5) / 3". Examples of symbols of supported mathematical operations are:
+ (addition), - (subtraction), * (multiplication), / (division), 
% (division remainder), ++ (increment), -- (decrement).

2) invalid_input - Optional. Accepts two values: “alert” and “silence”.
Default value is “silence”. If the value is “alert”, then in cases when 
the plugin has some problem with parameters,  PHP alert is being shown;
if the value is “silence”, then in cases when the plugin has 
some problem with parameters, it finishes its work without any alert being shown. 
Set this parameter to “alert” for development, and to “silence” - for deployment.

USAGE

Use this plugin as folllows:

{exp:math_plus calculate="(10 + 5) / 3"}
{math_plus_result}
{/exp:math_plus}

<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
// END USAGE

}

?>